macroScript OBJDimension
category:"jb_scripts"
tooltip:"Live Dimension in Viewport"
buttonText:"Dimension"
(
	global GW_displayObjectNames
	on isChecked return ::drawInViewportEnabled
	on execute do
	(
		if ::drawInViewportEnabled != true and ::drawInViewportEnabled != false do ::drawInViewportEnabled = false
		::drawInViewportEnabled = not ::drawInViewportEnabled
		if ::drawInViewportEnabled then
		(			
			unregisterRedrawViewsCallback GW_displayObjectNames
			fn GW_displayObjectNames =
			(
					if (selection.count == 1) then (
						local objMin = selection.min
						local objMax = selection.max
						local objX = ( units.formatValue ( objMax.x - objMin.x ) as string )
						local objY = ( units.formatValue ( objMax.y - objMin.y ) as string )
						local objZ = ( units.formatValue ( objMax.z - objMin.z ) as string )
						gw.wText [14,33,0] ("Dimension From " + selection[1].name + ":  X: " + objX + " | Y: " + objY + " | Z: " + objZ ) color: ( color 191 149 2 )
						) else if (selection.count > 1) then (
							local objMin = selection.min
							local objMax = selection.max
							local objX = ( units.formatValue ( objMax.x - objMin.x ) as string )
							local objY = ( units.formatValue ( objMax.y - objMin.y ) as string )
							local objZ = ( units.formatValue ( objMax.z - objMin.z ) as string )
							gw.wText [14,33,0] ("Dimension From Selection:  X: " + objX + " | Y: " + objY + " | Z: " + objZ ) color: ( color 191 149 2 )
							)
				gw.enlargeUpdateRect #whole
			)
			registerRedrawViewsCallback GW_displayObjectNames
		) else	(
			objMin = undefined
			objMax = undefined
			objX = undefined
			objY = undefined
			objZ = undefined
			unRegisterRedrawViewsCallback GW_displayObjectNames
			forceCompleteRedraw()
			)
		)		
)